package jtrek.applet;

import java.applet.*;
import java.net.URL;

import jtrek.visual.*;
import jtrek.Copyright;

public class AppletSoundEngine implements SoundEngine {
	
	AudioClip[] audio_clips = new AudioClip[28];
	
	public AppletSoundEngine(Applet applet) {
		URL codebase = applet.getCodeBase();
		audio_clips[SoundPlayer.FIRE_TORP_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/fire_torp.au");
		audio_clips[SoundPlayer.PHASER_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/fire_phaser.au");
		audio_clips[SoundPlayer.FIRE_PLASMA_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/fire_plasma.au");
		audio_clips[SoundPlayer.EXPLOSION_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/explosion.au");
		audio_clips[SoundPlayer.CLOAK_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/cloak.au");
		audio_clips[SoundPlayer.UNCLOAK_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/uncloak.au");
		audio_clips[SoundPlayer.SHIELD_DOWN_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/shield_down.au");
		audio_clips[SoundPlayer.SHIELD_UP_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/shield_up.au");
		audio_clips[SoundPlayer.TORP_HIT_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/torp_hit.au");
		audio_clips[SoundPlayer.WARNING_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/warning.au");
		audio_clips[SoundPlayer.ENGINE_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/engine.au");
		audio_clips[SoundPlayer.ENTER_SHIP_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/enter_ship.au");
		audio_clips[SoundPlayer.SELF_DESTRUCT_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/self_destruct.au");
		audio_clips[SoundPlayer.PLASMA_HIT_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/plasma_hit.au");
		audio_clips[SoundPlayer.MESSAGE_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/message.au");
		audio_clips[SoundPlayer.OTHER_FIRE_TORP_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/fire_torp_other.au");
		audio_clips[SoundPlayer.OTHER_PHASER_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/phaser_other.au");
		audio_clips[SoundPlayer.OTHER_FIRE_PLASMA_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/fire_plasma_other.au");
		audio_clips[SoundPlayer.OTHER_EXPLOSION_SOUND] = applet.getAudioClip(codebase, "./jtrek/applet/sounds/explosion_other.au");
		
		for(int i = SoundPlayer.MESSAGE1_SOUND; i <= SoundPlayer.MESSAGE9_SOUND; ++i) {
			audio_clips[i] = audio_clips[SoundPlayer.MESSAGE_SOUND];
		}
	}
	
	public void playSound(int sound) {
		audio_clips[sound].play();
	}
	
	public void abortSound(int sound) {
		audio_clips[sound].stop();
	}
}
