package jtrek.applet;

import netscape.javascript.*;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

import jtrek.Copyright;
import jtrek.Main;
import jtrek.config.*;
import jtrek.visual.*;

// For running the applet in Netscape 4 or IE 4
public class JTrek extends Applet implements Runnable {
	Button launch_button;
	SoundEngine sound_engine;
	
	public void init() {
		setLayout(null);
		launch_button = new Button("Launch Game");
		launch_button.setFont(new Font("Helvetica", Font.BOLD, 15));
		add(launch_button);
		Dimension d = getSize();
		launch_button.setBounds(0, 0, d.width, d.height);
		launch_button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				launchGame();
			}
		});
		sound_engine = new AppletSoundEngine(this);
	}
	
	public void launchGame() {
		(new Thread(JTrek.this, "JTrekApplet")).start();
	}
	
	public void run() {
		launch_button.setEnabled(false);
		
		String host = getParameter("host");
		if(host == null) {
			host = getCodeBase().getHost();
		}
		String port = getParameter("port");
		if(port == null) {
			port = "2592";
		}
		
		try {
			JSObject.getWindow(this).eval("loadProperties()");
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
		String[] params = { "-h", host, "-p", port, "-B", "-U", "1000" };
		Main main = new Main(params);
		main.view.sound_player.setSoundEngine(sound_engine);
		
		try {
			main.join();
		}
		catch(InterruptedException e) {
			e.printStackTrace();
		}
		
		launch_button.setEnabled(true);
	}
	
	public void loadProperties(String s) {
		Defaults.loadProperties(new StringBufferInputStream(s));
	}
}