package jtrek.comm;

import jtrek.Copyright;
import java.net.*;

class Reserved {
	// A "random" table we use to hose our data.
	static byte swap[][] = {
		{4, 13, 9, 7, 5, 8, 14, 2, 10, 11, 6, 3, 12, 15, 0, 1},
		{0, 4, 12, 5, 15, 2, 7, 3, 14, 6, 1, 10, 8, 13, 11, 9},
		{9, 5, 4, 2, 3, 6, 10, 12, 1, 7, 15, 14, 11, 0, 13, 8},
		{5, 8, 15, 4, 6, 9, 1, 12, 10, 3, 13, 11, 2, 7, 0, 14},
		{15, 13, 1, 14, 4, 0, 8, 12, 11, 9, 2, 10, 3, 6, 7, 5},
		{6, 7, 9, 11, 14, 1, 4, 13, 2, 12, 8, 15, 10, 0, 5, 3},
		{11, 0, 10, 14, 7, 12, 2, 4, 15, 13, 3, 9, 1, 5, 8, 6},
		{9, 8, 2, 10, 12, 14, 3, 7, 4, 0, 11, 1, 5, 15, 6, 13},
		{15, 12, 3, 0, 10, 8, 13, 9, 14, 2, 4, 5, 7, 6, 1, 11},
		{14, 3, 0, 11, 2, 10, 15, 12, 13, 1, 5, 4, 6, 8, 7, 9},
		{1, 2, 7, 3, 8, 0, 10, 14, 6, 5, 13, 12, 4, 9, 11, 15},
		{2, 1, 11, 9, 7, 3, 12, 6, 5, 8, 0, 10, 14, 4, 15, 13},
		{0, 12, 15, 1, 13, 7, 6, 5, 3, 14, 11, 8, 9, 10, 2, 4},
		{10, 9, 0, 6, 1, 14, 5, 12, 7, 4, 15, 13, 8, 2, 3, 11},
		{3, 11, 6, 12, 10, 5, 14, 1, 9, 15, 7, 2, 13, 8, 4, 0},
		{12, 6, 5, 8, 14, 4, 13, 15, 10, 0, 11, 9, 3, 1, 7, 2}
	};

	static byte[] encryptReservedPacket(byte[] sdata, InetAddress server, int pno) {
		byte[] buf = new byte[16];
		byte[] resp = new byte[16];
		System.arraycopy(sdata, 0, resp, 0, 16);

		byte[] address = server.getAddress();
		byte mixin1 = address[0];
		byte mixin2 = (byte)pno;
		byte mixin3 = address[1];
		byte mixin4 = address[2];
		byte mixin5 = address[3];

		byte[] s;
		int j = 0;
		for (int i = 0; i < 23; ++i) {
			j = (j + resp[j]) & 15;
			s = swap[j];
			resp[s[i % 7]] ^= mixin1;
			resp[s[i % 5]] ^= mixin2;
			resp[s[i % 13]] ^= mixin3;
			resp[s[i % 3]] ^= mixin4;
			resp[s[i % 11]] ^= mixin5;
			for (int k = 0; k < 16; k++) {
				buf[k] = resp[s[k]];
			}
			System.arraycopy(buf, 0, resp, 0, 16);
		}
		return resp;
	}
}